#ifndef _TXTLIN_HPP_
#define _TXTLIN_HPP_


#include"util.hpp"
#include"font.hpp"
#include"txtlin_text.hpp"
#include"screen.hpp"
#include"txtlin_packet.hpp"
#include<deque>


#define PROGNAME  "txtlin"


enum
SeekState
{
  SEK_null = 0,
  SEK_left,
  SEK_right,

};


using PacketList = std::deque<Packet>;


const PacketList&  get_packet_list();

void  reset_buffer();
void  advance();
void  fill_buffer();

int  get_head_offset();
int  get_head_pos();

void  increase_speed();
void  decrease_speed();

void  change_pause();




void  ready_textures();
void  clean_textures();

void     update_pos_texture(size_t  pos);
void  update_length_texture(           );

size_t  get_pos_texture_pos();

void  update_screen();



SeekState  get_seek_state();

int  get_seek_pos();

void  finish_seek();

void  update_seek_anmount_max();
void  start_seek(SeekState  st);
void  increase_seek_amount();
void  process_seek();




void  request_update();

void  start_main_loop();




#endif




