#include"txtlin.hpp"




namespace{


bool
loop_flag;


bool
update_flag;


void
process_keydown(const SDL_KeyboardEvent&  evt)
{
    switch(evt.keysym.sym)
    {
      case(SDLK_LEFT):
        start_seek(SEK_left);
        break;
      case(SDLK_RIGHT):
        start_seek(SEK_right);
        break;
    }
}


void
process_keyup(const SDL_KeyboardEvent&  evt)
{
    switch(evt.keysym.sym)
    {
      case(SDLK_f):
        change_fullscreen();
        break;
      case(SDLK_HOME):
        text::reset_pos(0);
        reset_buffer();
        break;
      case(SDLK_UP):
        text::reset_pos(get_head_pos()+(text::get_length()/20));
        reset_buffer();
        break;
      case(SDLK_DOWN):
        text::reset_pos(get_head_pos()-(text::get_length()/20));
        reset_buffer();
        break;
      case(SDLK_LEFT):
      case(SDLK_RIGHT):
        reset_buffer();

        finish_seek();
        break;
      case(SDLK_SPACE):
        change_pause();
        break;
      case(SDLK_z):
        decrease_speed();
        break;
      case(SDLK_x):
        increase_speed();
        break;
      case(SDLK_ESCAPE):
        loop_flag = false;
        break;
      case(SDLK_F5):
        screenshot(PROGNAME ".bmp");
        break;
    }
}


void
process_event()
{
  static SDL_Event  evt;

    while(SDL_PollEvent(&evt))
    {
        switch(evt.type)
        {
          case(SDL_DROPFILE):
            text::load(evt.drop.file);

            update_seek_anmount_max();

            SDL_free(evt.drop.file);

            update_length_texture();

            Packet::renew_cache();


            reset_buffer();
            break;
          case(SDL_KEYUP):
            process_keyup(evt.key);
            break;
          case(SDL_KEYDOWN):
            process_keydown(evt.key);
            break;
          case(SDL_MOUSEBUTTONDOWN):
              if((evt.button.clicks == 2) && (SDL_HasClipboardText()))
              {
                auto  s = SDL_GetClipboardText();

                  if(s)
                  {
                    text::reset(s);

                    update_seek_anmount_max();

                    update_length_texture();

                    Packet::renew_cache();

                    SDL_free(s);


                    reset_buffer();
                  }
              }
            break;
          case(SDL_QUIT):
            loop_flag = false;
            break;
        }
    }


  advance();

  fill_buffer();

  auto  pos = (get_seek_state()? get_seek_pos():get_head_pos());

    if(get_pos_texture_pos() != pos)
    {
      update_pos_texture(pos);
    }
}




}


void
request_update()
{
  update_flag = true;
}


void
start_main_loop()
{
  update_seek_anmount_max();

  update_length_texture();

  loop_flag = true;

    while(loop_flag)
    {
       process_seek();
      process_event();

        if(update_flag)
        {
          update_screen();

          update_flag = false;
        }


      SDL_Delay(16);
    }
}




